//+++======================================================================+++
//+++                  Ichimoku Kijun-sen Arrows TT [x3]                   +++
//+++======================================================================+++

#property copyright "  Tankk,  24  december  2015,  http://forexsystems.ru/" 
#property link "http://forexsystemsru.com/indikatory-foreks/80125-samye-tochnye-indikatory-strelochniki-podborka-i-obsuzhdenie.html"    //"http://forexsystemsru.com/1067902-post121.html" 

#property description "Kijun-sen     .    , ,    .     ,    ."
//#property version   "3.00"

#property indicator_chart_window
#property indicator_buffers 3

enum types { LINE, ARROW };

extern int   Tenkan  =  9,
              Kijun  =  26,
             Senkou  =  52;

extern types KijunType  =  LINE;
extern int   ArrowCode  =  110; 

extern color ColorKijun  =  SlateBlue;           //DodgerBlue;  // Lavender
extern ENUM_LINE_STYLE style  =  STYLE_SOLID;    //STYLE_SOLID _DOT _DASH;
extern int         size  =  2;

extern color    ArrowUP  =  White,      //Lime,  //White;    //DodgerBlue
                ArrowDN  =  Magenta;    //Red;   //Magenta;  //OrangeRed;
extern int   arrowsSize  =  0,
           arrowsUPcode  =  233,
           arrowsDNcode  =  234; 

extern bool        alert =  false;
extern string      File  =  "alert.wav";

/*extern string  arrowsCodes_42_120_110_108_117_121 = "139-149_171_172_174_181_203_85_86_91";
extern string _241_242_221_222_228_230_246_248    = "233-234_225-226_217-218_236-238_74-76";*/


//+++======================================================================+++
//+++                  Ichimoku Kijun-sen Arrows TT [x3]                   +++
//+++======================================================================+++
//indicator buffers
double CrossUp[], CrossDown[], Kijun_Buffer[];
    
    int date1 = 999;    int date2 = 999;    int date6 = 999;    int second = 20;    int a_begin;

string Name="Ichimoku TT";

//+++======================================================================+++
//+++              Custom indicator initialization function                +++
//+++======================================================================+++

int init()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0, CrossUp);
   SetIndexBuffer(1, CrossDown);
   SetIndexBuffer(2, Kijun_Buffer);
//----
   SetIndexStyle(0, DRAW_ARROW, -1, arrowsSize, ArrowUP);       SetIndexArrow(0, arrowsUPcode);
   SetIndexStyle(1, DRAW_ARROW, -1, arrowsSize, ArrowDN);       SetIndexArrow(1, arrowsDNcode);
//----
   int LNT = DRAW_NONE;    if (KijunType == LINE) LNT = DRAW_LINE;    if (KijunType == ARROW) LNT = DRAW_ARROW;  
   SetIndexStyle(2, LNT, style, size, ColorKijun);      SetIndexArrow(2, ArrowCode);
   SetIndexDrawBegin(2,Kijun-1);
//----
   SetIndexLabel(0, "Open BUY");
   SetIndexLabel(1, "Open SELL");
   SetIndexLabel(2, "Kijun-sen");
//----
   a_begin=Kijun; if(a_begin<Tenkan) a_begin=Tenkan;
//----
//----
   return(0);
  }
//+++======================================================================+++
//+++              Custom indicator deinitialization function              +++
//+++======================================================================+++
int deinit()
  {
  Comment("");
//----
   return(0);
  }
//+++======================================================================+++
//+++                 Custom indicator iteration function                  +++
//+++======================================================================+++
int start()
{
 
    double  GSignalUP=0 , SignalUP=0 , GSignalDOWN=0, SignalDOWN=0 , AllSignal=0 , BSignalUP=0, BSignalDOWN=0 ;

    double high,low,price;
    int k;
   
    if(Bars<=Tenkan || Bars<=Kijun || Bars<=Senkou) return(0);
//+++======================================================================+++
//+++======================================================================+++

   for (int i=Bars;i>=1;i--) 
   { 
      high=High[i]; low=Low[i]; k=i-1+Kijun;
      while(k>=i)
              {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
        
      Kijun_Buffer[i]=(high+low)/2;
//+++======================================================================+++

      if (Close[i]>=Kijun_Buffer[i] && Close[i+1]<Kijun_Buffer[i+1])
        {
         CrossUp[i] = Low[i]-5*Point;
         AllSignal++;
         SignalUP++;
         if (iClose(Symbol(),NULL,i-1)>iOpen(Symbol(),NULL,i-1))
         GSignalUP++;
         else BSignalUP++;
        }
//+++======================================================================+++
   
       else if (Close[i]<=Kijun_Buffer[i] && Close[i+1]>Kijun_Buffer[i+1])
         {
          CrossDown[i] = High[i]+5*Point;
          AllSignal++;
          SignalDOWN++;
          if (iClose(Symbol(),NULL,i-1)<iOpen(Symbol(),NULL,i-1))
          GSignalDOWN++;
          else BSignalDOWN++;
         }
   }
//+++======================================================================+++
//+++======================================================================+++

    int j=1;    i=1;

    int date3=TimeHour(Time[j]);    int date4=TimeMinute(Time[j]);    int date5=TimeDay(Time[j]);
//+++======================================================================+++

 if (Close[i]>=Kijun_Buffer[i] && Close[i+1]<Kijun_Buffer[i+1] && alert==true && date1!=date3 && date2!=date4 && date5!=date6 && Seconds()<second)
        {date1=date3; date2=date4; date6=date5; Alert (Name," - BUY  ",Symbol()," at ",iClose(Symbol(),0,i)); PlaySound(File); }
//+++======================================================================+++

 if (Close[i]<=Kijun_Buffer[i] && Close[i+1]>Kijun_Buffer[i+1] && alert==true && date1!=date3 && date2!=date4 &&  date5!=date6 && Seconds()<second)
        {date1=date3; date2=date4; date6=date5; Alert (Name," - SELL  ",Symbol()," at ",iClose(Symbol(),0,i)); PlaySound(File); }
//+++======================================================================+++
//+++======================================================================+++

   return(0);
}
//+++======================================================================+++
//+++                  Ichimoku Kijun-sen Arrows TT [x3]                   +++
//+++======================================================================+++

